      subroutine llh2xyz(llh, xyz)
      implicit none
c
      real*8         llh(3), xyz(3)
c
c     ... Local variables
c
      real*8         clat, slat, clon, slon
      real*8         a, f, e2, n, deg2rad
c
c     ... Code
c
      deg2rad = datan(1.d0)/45.d0
c
      clat = cos(llh(1)*deg2rad)
      slat = sin(llh(1)*deg2rad)
      clon = cos(llh(2)*deg2rad)
      slon = sin(llh(2)*deg2rad)
c
c     ... Transform from lat, lon, h to x, y, z
c
      a = 6378137.d0
      f = 1.d0/298.257223563d0
      e2 = 2.d0*f - f*f
      n = a/sqrt((1.d0 - e2*slat**2))
c
c     ... Compute x, y, z
c
      xyz(1) = (n + llh(3))*clat*clon
      xyz(2) = (n + llh(3))*clat*slon
      xyz(3) = (n*(1.d0-e2) + llh(3))*slat
c
      return
      end
