      subroutine write_hfile(luout,n,ncov,lab,lat,lon,
     +                       nrms,apr_m,m,cov_m)

* Output model and covariance in hfile format

      implicit undefined (a-z)

      integer       i,j,n,ncov,luout
      real          apr_m(*),m(*),cov_m(ncov,*)
      real          lat(*),lon(*),nrms
      character*(*) lab(*)
      character     scode*4
      
      write (luout,'(a,i3)') ' Number of stations: ',n/2
      write (luout,'(a)') ' Name of track stations'
      do i = 1,n/2
         scode = lab(i*2)(1:4)
* Original glohed format:
*        write (luout,'(1x,i3,2x,a4,2x,a12,3x,i6)') 
* Revised to include lon,lat
         write (luout,'(1x,i3,2x,a4,2x,a8,4x,3x,2f12.5)') 
     +       i,scode,lab(i*2)(1:8),lon(i),lat(i)
      enddo

      write(luout,'(a,i5,3x,a,i5)')
     .   ' Total parameters: ', n
     .,   'live parameters: ', n

      write(luout,'(a,e12.5,4x,a,e12.5)')
     .   ' Prefit nrms: ',0.0
     .,   'Postfit nrms:',nrms

      write(luout,'(/,8x,a,17x,a,16x,a)')  
     +    'label (units)','a priori','adjustment' 

      do i = 1, n
* Original glohed format:
*        write(luout,'(1x,i4,a1,a20,1x,d23.16,4x,d23.16)')
* Revised to output sigmas
         write(luout,'(1x,i4,a1,a20,1x,d23.16,4x,d23.16,
     +                 4x,d23.16)')
     +      i,' ',lab(i),dble(apr_m(i)),dble(m(i)),
     +      dble(sqrt(cov_m(i,i)))
      enddo

      write (luout,'(/,a)') ' Covariance matrix: '

      do i = 1, n
         write(luout,110) i,(dble(cov_m(i,j)),j=1,i)
 110     format (1x,i3,'. ',500(5(1x,d23.16),:,/,6x))
      enddo

      return
      end
