	subroutine rotcov(qinn,mdim,qinn3,mdim0,nmstus,lat,lon)
c	rotate covariance matrix qinn2 from EN coord. to qinn3
c	in XYZ coord.
	real lat(mdim),lon(mdim)
	real qinn(mdim,mdim)
	real*8 qval
	real*8 alph(500,3)
	real*8 qinn3(3*mdim0,3*mdim0)
	pi=3.14159265
	rad=180./pi
		write(6,*)'ROTCOV:'
        write(6,*)'qinn=',qinn(1,1),qinn(1,2),qinn(1,3),qinn(1,4)

	do 7 i=1,nmstus
	i1=3*i-2
	i2=3*i-1
	i3=3*i
	clat=cos(lat(i)/rad)
	slat=sin(lat(i)/rad)
	clon=cos(lon(i)/rad)
	slon=sin(lon(i)/rad)
c	alph(i1,_) gives phi-hat (E-direction), alph(i2,_) gives theta-hat (N-).
c	alph(i3,_) gives r-hat (U-).
	alph(i2,1)=dfloat(-slat*clon)
	alph(i2,2)=dfloat(-slat*slon)
	alph(i2,3)=dfloat(clat)
	alph(i1,1)=dfloat(-slon)
	alph(i1,2)=dfloat(clon)
	alph(i1,3)=0.d0
	alph(i3,1)=dfloat(clat*clon)
	alph(i3,2)=dfloat(clat*slon)
	alph(i3,3)=dfloat(slat)
7	continue
	do 10 k=1,nmstus
	k1=3*k-2
	k2=3*k-1
	k3=3*k
	do 20 l=1,nmstus
	l1=3*l-2
	l2=3*l-1
	l3=3*l
	qinn3(k1,l1)=0.d0
	qinn3(k1,l2)=0.d0
	qinn3(k1,l3)=0.d0
	qinn3(k2,l1)=0.d0
	qinn3(k2,l2)=0.d0
	qinn3(k2,l3)=0.d0
	qinn3(k3,l1)=0.d0
	qinn3(k3,l2)=0.d0
	qinn3(k3,l3)=0.d0
	do 30 ip=1,3
	do 40 iq=1,3
	k02=2*k-2+ip
	l02=2*l-2+iq
	k0=3*k-3+ip
	l0=3*l-3+iq
	qval=0.d0
	if(ip.lt.3.and.iq.lt.3) qval=dfloat(qinn(k02,l02))
	if(ip.lt.3.and.iq.lt.3) go to 8
c	next line: artificially put in standard deviation of 0.01 for
c	"vertical data" in next line.
	if(k0.eq.l0) qval=(0.01d0)**2
8	qinn3(k1,l1)=qinn3(k1,l1)+alph(k0,1)*alph(l0,1)*qval
	qinn3(k1,l2)=qinn3(k1,l2)+alph(k0,1)*alph(l0,2)*qval
	qinn3(k1,l3)=qinn3(k1,l3)+alph(k0,1)*alph(l0,3)*qval
	qinn3(k2,l1)=qinn3(k2,l1)+alph(k0,2)*alph(l0,1)*qval
	qinn3(k2,l2)=qinn3(k2,l2)+alph(k0,2)*alph(l0,2)*qval
	qinn3(k2,l3)=qinn3(k2,l3)+alph(k0,2)*alph(l0,3)*qval
	qinn3(k3,l1)=qinn3(k3,l1)+alph(k0,3)*alph(l0,1)*qval
	qinn3(k3,l2)=qinn3(k3,l2)+alph(k0,3)*alph(l0,2)*qval
	qinn3(k3,l3)=qinn3(k3,l3)+alph(k0,3)*alph(l0,3)*qval
40	continue
30	continue
20	continue
10	continue
		write(6,*)'rotcov: qinn3(1,1),qinn3(1,2),qinn3(1,3),
&	qinn3(1,4),qinn3(1,5)='
		write(6,*) qinn3(1,1),qinn3(1,2),qinn3(1,3),qinn3(1,4),
&	qinn3(1,5)
      return
      end
	
