      subroutine wrtvel(uout, maxvec, stanam, xyz, dxyz,
     +                   covxyz, nvec, refsta, refxyz, crdsys)
      implicit none
c
c     ... Write a standard displacement file
c
      integer       uout, maxvec, nvec
      character*8   stanam(maxvec), refsta, parmname(3)
      real*8        xyz(3,maxvec), dxyz(3,maxvec)
      real*8        covxyz(3*maxvec,3*maxvec), refxyz(3)
      character*3   crdsys
c
c     ... Local vars
c
      integer      i, j, k, n
c
c     ... Check the reference station. There must be a reference
c         station if the coordinate system is not XYZ.
      if (refsta.eq.' ' .and. crdsys.ne.'XYZ') then
         write(6,*) 'Error - No reference station specified'
         call exit(1)
      endif
c
c     ... Number of parameters
c
      write(unit=uout, fmt='(X,I4,A8,X,A3)') nvec*3, refsta, crdsys
c
c     ... Station names and coordinates
c
      do i = 1, nvec
         write(uout,*) stanam(i), (xyz(j,i), j=1,3)
      enddo
      if (refsta.ne.' ' .and. refsta.ne.'*')
     +       write(uout,*) refsta, (refxyz(j), j=1,3)
c
c     ... Parameter names and values
c
      if (crdsys .eq. 'XYZ') then
         parmname(1) = 'VEL  X  '
         parmname(2) = 'VEL  Y  '
         parmname(3) = 'VEL  Z  '
      else if (crdsys .eq. 'ENU') then
         parmname(1) = 'VEL  E  '
         parmname(2) = 'VEL  N  '
         parmname(3) = 'VEL  U  '
      endif
      n = 0
      do i = 1, nvec
         k = 3*(i - 1)
         n = n + 1
         write(uout,'(X,I4,2X,A16,2X,E22.15,2X,''+-'',2X,E21.15)')
     +     n, parmname(1)//stanam(i), dxyz(1,i), dsqrt(covxyz(k+1,k+1))
         n = n + 1
         write(uout,'(X,I4,2X,A16,2X,E22.15,2X,''+-'',2X,E21.15)')
     +     n, parmname(2)//stanam(i), dxyz(2,i), dsqrt(covxyz(k+2,k+2))
         n = n + 1
         write(uout,'(X,I4,2X,A16,2X,E22.15,2X,''+-'',2X,E21.15)')
     +     n, parmname(3)//stanam(i), dxyz(3,i), dsqrt(covxyz(k+3,k+3))
      enddo
c
c     ... Now the covariance elements
c
      do i = 1, 3*nvec
         do j = 1, i-1
            if (covxyz(i,i).eq.0.d0 .or. covxyz(j,j).eq.0.d0) then
               write(uout,'(X,I4,2X,I4,2X,E22.15)') i, j, 0.d0
            else
               write(uout,'(X,I4,2X,I4,2X,E22.15)')
     +            i, j, covxyz(j,i)/dsqrt(covxyz(i,i)*covxyz(j,j))
            endif
         enddo
      enddo
c
      return
      end
