      subroutine getdata(uot,udt,datdim,ndim,ndat,dataop,llcsn,
     +                  angsn,gpssn,vlbisn,azsn,stdev,d,stdevt,dtemp)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   this subroutine to read data and to form data vector and vector c
c   of standard deviations for all types of data.                   c
c   uot = unit number of general output file                        c
c   udt = unit number of data file                                  c
c   d   = data vector for all types of data                         c
c   stdev = vector of standard deviations                           c
c   count = counter to save the number of data up to current data   c
c           type                                                    c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer uot,ndim,datdim,count,i,n,j
      integer ndat(20),udt
      real stdev(ndim), d(ndim), stdevt(datdim), dtemp(datdim)
      character*1   dataop(10)
      character*(*) llcsn(2,ndim),angsn(3,datdim),gpssn(2,datdim),
     .              vlbisn(datdim),azsn(2,datdim)

c.....initialize ndat(i) to zeros
      do 5 i=1,4
        ndat(i)=0
  5   continue

      count=0
c.....call different subroutine according to different data option

c.....line length change data
      if (dataop(1).eq.'y') then
        call gdata(uot,udt,datdim,ndat(1),llcsn,stdev,d)
        count = count + ndat(1)
      endif
c
c.....angle change data
      if (dataop(2).eq.'y') then
        call gdataa(uot,udt,datdim,ndat(2),angsn,stdevt,dtemp)
        do 20 i=count+1,count+ndat(2)
          stdev(i)=stdevt(i-count)
          d(i)=dtemp(i-count)
  20    continue 
        count = count + ndat(2)
      endif


c.....gps data 
      if (dataop(3).eq.'y') then
        call gdatgps(uot,udt,datdim,ndat(3),gpssn,stdevt,dtemp)
        do 30 i=count+1,count+ndat(3)
          stdev(i)=stdevt(i-count)
          d(i)=dtemp(i-count)
  30    continue 
        count = count + ndat(3)
      endif

c.....vlbi data
      if (dataop(4).eq.'y') then
        call gdatvlbi(uot,udt,datdim,ndat(4),vlbisn,stdevt,dtemp)
        do 40 i=count+1,count+ndat(4)
          stdev(i)=stdevt(i-count)
          d(i)=dtemp(i-count)
  40    continue 
        count = count + ndat(4)
      endif

c.....astro-azimuth data
      if (dataop(5).eq.'y') then
        call gdataz  (uot,udt,datdim,ndat(5),azsn,stdevt,dtemp)
        do 50 i=count+1,count+ndat(5)
          stdev(i)=stdevt(i-count)
          d(i)=dtemp(i-count)
  50    continue 
        count = count + ndat(5)
      endif

      return
      end


c*************************************************************
c
      subroutine gdataa(uot,udt,datdim,numdat,angsn,stdev,d)
c
c....this subroutine reads angle change data
c
      integer uot, udt, datdim, numdat, i
      real stdev(datdim), d(datdim)
      character*8 angsn(3,datdim)
      character*50 angchnam
c
c......read input file name
      call getfile2(udt,'angle change data file name','in',
     +               'formatted',angchnam)
      write(uot,*)' '
      write(uot,*)'angle change data file: ',angchnam
c
c.....write header to output file
      write(uot,*)' '
      write(uot,10)
  10  format(2x,'station1',2x,'station2',2x,'station3',2x,
     +           'angle change',2x,'st.dev.')
c
c.....read angle change data 
      i=1

  20  read(udt,50,end=30)angsn(1,i),angsn(2,i),angsn(3,i),d(i),stdev(i)
      write(uot,50) angsn(1,i),angsn(2,i),angsn(3,i),d(i),stdev(i)
      i=i+1
  50  format(1x,a8,1x,a8,1x,a8,5x,f12.6,5x,f8.5)
      go to 20
  30  continue
      numdat=i-1
c
      write(uot,*) ' '
      write(uot,*) 'number of data for angle change= ',numdat
      close(unit=udt)
c
      if (numdat.gt.datdim) then
        print *,'number of data exceeds array dimension datdim'
        print *,'increase dimension of the data array'
        stop
      endif
c
      return
      end
c
c*************************************************************
c....this subroutine reads in gps data 
      subroutine gdatgps(uot,udt,datdim,numdat,gpssn,stdev,d)

      integer uot, udt, datdim, numdat, i
      real stdev(datdim), d(datdim)
      real east, easts, north, norths, up, ups
      character*8 gpssn(2,datdim), sta1, sta2
      character*50 filnam

c......read input file name
      call getfile2(udt,'gps vector data file name','in',
     +               'formatted',filnam)
      write(uot,*)' '
      write(uot,*)'GPS Vector data file: ',filnam
c
c.....write header to output file
      write(uot,*)' '
      write(uot,10)
  10  format(2x,'station1',' - ','station2',2x,
     +      '   EAST   ','   +/-    ',
     +      '   NORTH  ','   +/-    ',
     +      '    UP    ','   +/-    ')
c
c.....read data 
      i=1

  20  read(udt,*,end=30) sta1,sta2,east,easts,north,norths,up,ups
      write(uot,50) sta1,sta2,east,easts,north,norths,up,ups
  50  format(1x,a8,1x,a8,4x,6(1x,f8.5,1x))

c.....east component
      gpssn(1,i) = sta1
      gpssn(2,i) = sta2
      d(i)       = east
      stdev(i)   = easts
      i=i+1

c.....north  component
      gpssn(1,i) = sta1
      gpssn(2,i) = sta2
      d(i)       = north
      stdev(i)   = norths
      i=i+1

      go to 20
  30  continue
      numdat=i-1
c
      write(uot,*) ' '
      write(uot,*) 'number of gps data = ',numdat
      close(unit=udt)
c
      if (numdat.gt.datdim) then
        print *,'number of data exceeds array dimension datdim'
        print *,'increase dimension of the data array'
        stop
      endif
c
      return
      end



c*************************************************************
c....this subroutine reads in vlbi data 
      subroutine gdatvlbi(uot,udt,datdim,numdat,vlbisn,stdev,d)

      integer uot, udt, datdim, numdat, i
      real stdev(datdim), d(datdim)
      real east, easts, north, norths, up, ups
      character*8 vlbisn(datdim), sta
      character*50 filnam

c......read input file name
      call getfile2(udt,'VLBI vector data file name','in',
     +               'formatted',filnam)
      write(uot,*)' '
      write(uot,*)'VLBI Vector data file: ',filnam
c
c.....write header to output file
      write(uot,*)' '
      write(uot,10)
  10  format(2x,'station1',2x,
     +      '   EAST   ','   +/-    ',
     +      '   NORTH  ','   +/-    ',
     +      '    UP    ','   +/-    ')
c
c.....read data 
      i=1

  20  read(udt,*,end=30) sta,east,easts,north,norths,up,ups
      write(uot,50) sta,east,easts,north,norths,up,ups
  50  format(2x,a8,2x,6(1x,f8.5,1x))

c.....east component
      vlbisn(i)  = sta
      d(i)       = east
      stdev(i)   = easts
      i=i+1

c.....north  component
      vlbisn(i)  = sta
      d(i)       = north
      stdev(i)   = norths
      i=i+1

      go to 20
  30  continue
      numdat=i-1
c
      write(uot,*) ' '
      write(uot,*) 'number of VLBI data = ',numdat
      close(unit=udt)
c
      if (numdat.gt.datdim) then
        print *,'number of data exceeds array dimension datdim'
        print *,'increase dimension of the data array'
        stop
      endif
c
      return
      end

c*************************************************************
      subroutine gdataz(uot,udt,datdim,numdat,azsn,stdev,d)
c
c....this subroutine reads azimuth change data
c
      integer uot, udt, datdim, numdat, i
      real stdev(datdim), d(datdim)
      character*8 azsn(2,datdim)
      character*50 azinam
c
c.....read input file name
      call getfile2(udt,'azimuth change data file name','in',
     +               'formatted',azinam)
      write(uot,*)' '
      write(uot,*)'azimuth change data file: ',azinam
c
c.....write header to output file
      write(uot,*)' '
      write(uot,*)'Positive Change Counter-Clockwise '
      write(uot,10)
  10  format(2x,'From Station1',2x,'To Station2',2x,'azimuth change',
     .                                                   2x,'st.dev.')
c
c.....read angle change data 
      i=1

  20  read(udt,50,end=30)azsn(1,i),azsn(2,i),d(i),stdev(i)
      write(uot,50) azsn(1,i),azsn(2,i),d(i),stdev(i)
      i=i+1
  50  format(5x,a8,4x,a8,5x,f12.6,5x,f8.5)
      go to 20
  30  continue
      numdat=i-1
c
      write(uot,*) ' '
      write(uot,*) 'Number of azimuth changes = ',numdat
      close(unit=udt)
c
      if (numdat.gt.datdim) then
        print *,'number of data exceeds array dimension datdim'
        print *,'increase dimension of the data array'
        stop
      endif
c
      return
      end
c
      Subroutine Gdata(uot,udt,ndim,numdat,llcsn,stdev,d)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C GET DATA FILE NAMES AND READ THE DATA                          C
C                                                                C
C INPUT:                                                         C
C      uot    =  unit number of output file                      C
C      udt    =  unit number of data file                        C
C      ndim   =  dimension of arrays                             C
C OUTPUT:                                                        C
C      numdat = number of data read from udt                     C
C      llcsn  = pairs of station names for each baseline         C
C      d      = data vector line length changes                  C
C      stdev  = vector of standard deviations                    C
C                                                                C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer uot, udt, ndim, numdat
      Real d(ndim), stdev(ndim)
      Character*8 llcsn(2,ndim)
      Character    dname*50, type*1, form*1

C ....Read Input File Name
      Call getfile2(udt,'line length data file name',
     +                      'in','formatted',dname)
      Write(uot,*)' '
      Write(uot,*)'Line length data file: ',dname

C ....Determine File Type and Read
      Call getopt('Is file single data or pairs?','s/p','s',form)
      If (form.eq.'s') then
        call geodr(udt,uot,ndim,numdat,llcsn,d,stdev)
      else
        call getopt('geodolite/HVO format','g/h','g',type)
        If (type.eq.'g')
     +     call geodp(udt,uot,ndim,numdat,llcsn,d,stdev)
        If (type.eq.'h')
     +     call hawdp(udt,uot,ndim,numdat,llcsn,d,stdev)
      EndIf


      Write(uot,*)' '
      Write(uot,*)'Number of data read = ',numdat
      Close(unit=udt)
     
      if(numdat.gt.ndim) then
        print *, 'number of data exceeds array dimension ndim'
        print *, 'increase ndim in parameter statement'
        stop
      endif

      RETURN
      END


      Subroutine geodr(udt,uot,ndim,numdat,llcsn,d,stdev)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C GET CHANGE IN LINE LENGTHS OR RATES AND STANDARD DEVIATIONS    C
C Reads from udt and writes to uot.                              C
C Counts the number of data in the file (numdat).                C
C INPUT:                                                         C
C      udt     = unit number of input file                       C
C      uot     = unit number of output file                      C
C      ndim    = dimension of arrays                             C
C OUTPUT:                                                        C
C      numdat  = number of data read                             C
C      llcsn   =  array of two station names for each datum      C
C      d       =  array of all data                              C
C      stdev   =  array of all standard deviations               C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer k, udt, uot, ndim, numdat
      Character eof*1, net*5
      Character*8 llcsn(2,ndim)
      Real distan, d(ndim), stdev(ndim), azi

C.... write header to output file
      Write(uot,*)' '
      Write(uot,10)
   10 Format(2x,'net',5x,'sta1',5x,'sta2',6x,'distan',5x,'line ch',
     +       2x,'st.dev')

      k=1
   20 call r1rate(udt,net,llcsn(1,k),llcsn(2,k),distan,d(k),stdev(k),
     +                                                      azi,eof)
      if(eof.eq.'y') go to 100
      Write(uot,15) net,llcsn(1,k),llcsn(2,k),distan,d(k),stdev(k)
      k=k+1
      Go to 20

   15 Format(1x,a4,2x,a8,1x,a8,2x,f10.3,2x,f7.4,2x,f6.4)
  100 continue
C.....return number of data = numdat
      numdat = k-1

      RETURN
      END


      Subroutine r1rate(uin,net,sta1,sta2,distan,deltal,stdev,azi,eof)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C READ LINE-LENGTH DIFFERENCES OR RATES                          C
C INPUT:                                                         C
C         uin    =  unit number of input file                    C
C OUTPUT:                                                        C
C         net    =  net name (character string)                  C
C         sta1   =  first station name (character string)        C
C         sta2   =  second station name (character string)       C
C         distan =  nominal distance (meters)                    C
C         deltal =  change in length (meters or meters/yr)       C
C         stdev  =  standard deviation of delatal (meters or ...)C
C         azi    =  azimuth                                      C
C         eof    =  'y' on end of file; otherwise 'n'            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer uin 
      Character*1 eof
      Character*5 net
      Character*8 sta1, sta2 
      Real distan, deltal, stdev, azi

      eof = 'n'
      Read(uin,10,end=20) net,sta1,sta2,distan,deltal,stdev,azi
      go to 30

   20 eof = 'y'
   10 Format(a5,8x,a8,1x,a8,t44,f10.3,t54,f7.4,1x,f6.4,t69,f5.1)

   30 RETURN
      END
  



      Subroutine geodp(udt,uot,ndim,numdat,llcsn,d,stdev)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C GEODOLITE DATA PAIRS                                           C
C Reads all the data associated with the geodolite line pairs.   C
C Writes the data and associated info to the output file.        C
C Reads from udt and writes to uot.                              C
C Counts the number of data in the file (numdat).                C
C INPUT:                                                         C
C      udt     = unit number of input file                       C
C      uot     = unit number of output file                      C
C      ndim    = dimension of arrays                             C
C OUTPUT:                                                        C
C      numdat  = number of data read                             C
C      llcsn   =  array of two station names for each datum      C
C      d       =  array of all data                              C
C      stdev   =  array of all standard deviations               C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer k, udt, uot, ndim, numdat, iyr, imo, iday
      Character eof*1, type*3, net*5
      Character*8 sta1, sta2, sta1n, sta2n, llcsn(2,ndim)
      Real a, b, d(ndim), stdev(ndim), azi, var1, var2
      Real*8  mmd1, mmd2, cad1, cad2

C.... write header to output file
      Write(uot,*)' '
      Write(uot,10)
   10 Format(2x,'net',5x,'sta1',5x,'sta2',6x,'distan',5x,'line ch',
     +       2x,'st.dev')

      k=1
   20 call r1gdg(udt,net,sta1,sta2,iyr,imo,iday,azi,mmd1,
     +                 cad1,type,eof)
      if(eof.eq.'y') go to 100
      call stdtyp(type,a,b)
      var1 = a**2 + (mmd1 * b* 1.0e-6)**2

      call r1gdg(udt,net,sta1n,sta2n,iyr,imo,iday,azi,mmd2,
     +                 cad2,type,eof)
      if(sta1.eq.sta1n .and. sta2.eq.sta2n) then
         llcsn(1,k) = sta1
         llcsn(2,k) = sta2
         d(k) = mmd2 - mmd1
         call stdtyp(type,a,b)
         var2 = a**2 + (mmd2 * b* 1.0e-6)**2
         stdev(k) = sqrt(var1 + var2)
         Write(uot,15) net,sta1,sta2,mmd2,d(k),stdev(k)
      else
         print *, 'No match for baseline', sta1, sta2, 'in routine'
         print *, 'GEODP. Check data file'
         stop
      endif

      k=k+1
      Go to 20

   15 Format(1x,a4,2x,a8,1x,a8,2x,f10.3,2x,f7.4,2x,f6.4)
  100 continue
C.....return number of data = numdat
      numdat = k-1

      write(uot,*) '  '
      write(uot,*) '  '
      write(uot,*) 'Variance of Data assumed to be: a**2 + b**2 * L**2'     
      write(uot,*) 'Geodolite: a = 3.0 mm and b = 0.20E-6 '
      write(uot,*) 'G8/CDMG  : a = 6.0 mm and b = 0.70E-6 '
      write(uot,*) 'G2       : a = 10. mm and b = 1.00E-6 '
      write(uot,*) 'Covariance of Data assumed to be 0.0'

      RETURN
      END

      Subroutine stdtyp(type,a,b)
      Integer index
      Character type
      Real a, b, aa(3), bb(3) 

      data aa/0.010, 0.006, 0.003/
      data bb/1.000, 0.700, 0.200/

      index = 3
      if (type.eq.' g2') index=1
      if (type.eq.'dmg') index=2
      if (type.eq.' g8') index=2

      a = aa(index)
      b = bb(index)

      RETURN
      END





      Subroutine r1gdg(uin,net,sta1,sta2,iyr,imo,iday,azi,mmd,
     +                 cad,type,eof)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C READ SINGLE GEODIMETER DATUM; GEODOLITE FORMAT                 C
C INPUT:                                                         C
C         uin    =  unit number of input file                    C
C OUTPUT:                                                        C
C         net    =  net name (character string)                  C
C         sta1   =  first station name (character string)        C
C         sta2   =  second station name (character string)       C
C         iyr    =  integer year                                 C
C         imo    =  integr month                                 C
C         iday   =  integr day                                   C
C         azi    =  azimuth                                      C
C         mmd    =  mark-to-mark distance (meters)               C
C         cad    =  'Clark-arc distance (meters)                 C
C         eof    =  'y' on end of file; otherwise 'n'            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer uin, iyr, imo, iday
      Character*1 eof
      Character*3 type
      Character*5 net
      Character*8 sta1, sta2 
      Real*8  mmd, cad
      Real azi

      eof = 'n'
      read(uin,10,end=20) net,sta1,sta2,iyr,imo,iday,azi,mmd,cad,
     $                     type
      go to 30

   20 eof = 'y'
   10 format(a5,t7,a8,1x,a8,1x,i2,i2,i2,t37,f5.0,t43,f11.4,t56,
     $                     f11.4,t76,a3)

   30 RETURN
      END




      Subroutine hawdp(udt,uot,ndim,numdat,llcsn,d,stdev)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C HAWAII HVO GEODIMETER DATA PAIRS                               C
C Reads all the data associated with HVO geodimetr line pairs.   C
C Writes the data and associated info to the output file.        C
C Reads from udt and writes to uot.                              C
C Counts the number of data in the file (numdat).  Fills the     C
C following arrays:                                              C
C llcsn   =  array of two station names for each datum           C
C d       =  array of all data                                   C
C stdev   =  array of all standard deviations                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer k, udt, uot, ndim, numdat, iyr, ijd
      Character*1 eof
      Character*4 net
      Character*3 lnum1, lnum2
      Character*8 sta1, sta2, llcsn(2,ndim)
      Real*8  mmd1, mmd2, cad1, cad2
      Real a, b, d(ndim), stdev(ndim)

      a = 0.010
      b = 1.000
      Print *, 'Variance of Data assumed to be: a**2 + b**2 * L**2'     
      Print *, 'With a = 0.010 meters and b = 1.0E-6 '
      Print *, 'Covariance assumed to be 0.0'

C.... write header to output file
      Write(uot,*)' '
      Write(uot,10)
   10 Format(2x,'net',5x,'sta1',5x,'sta2',6x,'distan',5x,'line ch',
     +       2x,'st.dev')

      k=1
   20 call r1gdh(udt,net,lnum1,sta1,sta2,iyr,ijd,mmd1,cad1,eof)
      if(eof.eq.'y') go to 100

      call r1gdh(udt,net,lnum2,sta1,sta2,iyr,ijd,mmd2,cad2,eof)
      if(lnum1.eq.lnum2) then
         llcsn(1,k) = sta1
         llcsn(2,k) = sta2
         d(k) = mmd2 - mmd1
         stdev(k) = sqrt(2 * a**2 + 2 * (mmd2*b*1.0e-6)**2)
         Write(uot,15) net,sta1,sta2,mmd2,d(k),stdev(k)
      else
         print *, 'No match for baseline', lnum1, 'in routine hawdp'
         print *, 'Check data file'
         stop
      endif

      k=k+1
      Go to 20


   15 Format(1x,a4,2x,a8,1x,a8,2x,f10.3,2x,f7.4,2x,f6.4)
  100 continue
C.....return number of data = numdat
      numdat = k-1

      RETURN
      END





      Subroutine r1gdh(uin,net,lnum,sta1,sta2,iyr,ijd,mmd,cad,eof)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C READ SINGLE GEODIMETER DATUM; HAWAII FORMAT                    C
C INPUT:                                                         C
C         uin    =  unit number of input file                    C
C OUTPUT:                                                        C
C         net    =  net name (character string)                  C
C         lnum   =  line number (character string)               C
C         sta1   =  first station name (character string)        C
C         sta2   =  second station name (character string)       C
C         iyr    =  integer year                                 C
C         ijd    =  integr julian day                            C
C         mmd    =  mark-to-mark distance (meters)               C
C         cad    =  'Clark-arc distance (meters)                 C
C         eof    =  'y' on end of file; otherwise 'n'            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer uin, iyr, ijd
      Character*1 eof
      Character*4 net
      Character*3 lnum
      Character*8 sta1, sta2 
      Real*8  mmd, cad

      eof = 'n'
      Read(uin,10,end=20) net,lnum,sta1,sta2,iyr,ijd,mmd,cad
      go to 30

   20 eof = 'y'
   10 Format(a4,a3,5x,a8,7x,a8,12x,i2,i3,6x,f10.4,1x,f10.4)

   30 RETURN
      END

      Subroutine r1gdhn(uin,net,lnum,sta1,sta2,iyr,ijd,mmd,eof)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C READ SINGLE GEODIMETER DATUM; HAWAII FORMAT                    C
C INPUT:                                                         C
C         uin    =  unit number of input file                    C
C OUTPUT:                                                        C
C         net    =  net name (character string)                  C
C         lnum   =  line number (character string)               C
C         sta1   =  first station name (character string)        C
C         sta2   =  second station name (character string)       C
C         iyr    =  integer year                                 C
C         ijd    =  integr julian day                            C
C         mmd    =  mark-to-mark distance (meters)               C
C         cad    =  'Clark-arc distance (meters)                 C
C         eof    =  'y' on end of file; otherwise 'n'            C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer uin, iyr, ijd
      Character*1 eof
      Character*4 net
      Character*4 lnum
      Character*8 sta1, sta2 
      Real*8  mmd, cad

      eof = 'n'
      Read(uin,11,end=20) net,lnum,sta1,sta2,iyr,ijd,mmd
      go to 30

   20 eof = 'y'
   11 Format(a2,a4,4x,a8,8x,a8,13x,i2,i3,6x,f10.4)

   30 RETURN
      END



      Subroutine Datwgt(ndim,stdev,totdat,td,tdinv)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C FORM DATA WEIGHT MATRIX td AND ITS INVERSE tdinv        C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer totdat, ndim, j, n
      Real stdev(ndim), td(ndim,ndim), tdinv(ndim,ndim)
 
      Do 400 n=1,totdat
          Do 300 j=1,totdat
              If (j.eq.n)    td(j,n) = 1.0/stdev(n)
              If (j.eq.n) tdinv(j,n) = stdev(n)
              If (j.ne.n)    td(j,n) = 0.0
              If (j.ne.n) tdinv(j,n) = 0.0
  300     Continue
  400 Continue
      RETURN
      END
 

