CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  pltgeodnet.for                                                    C
C                                                                    C
C  PROGRAM TO PLOT GEODIMETER NETWORKS                               C
C                                    thrown together by PSegall      C
C                                    July 13 1987                    C
C                                    last modified Feb 10 1988       C
C  Program will ask for the data files, and the station files where  C
C  the stations coordinates lie.  The output should be in proper     C
C  format to plot with QPLOT                                         C
C  stadim   =  number of stations                                    C
C  uot     =  unit number for general output file                    C
C  ust     =  unit number for station coordinate file                C
C  udt     =  unit number for data input files                       C
C  numst   = number of stations                                      C
C  sta     = char array of station names                             C
C  llcsn   = array of pairs of station names for each line change    C
C              and model coord solutions respectively                C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  MAIN PROGRAM
C
C THE USER MUST SET THE ARRAY DIMENSIONS IN THE FOLLOWING
C PARAMETER STATEMENTS
C
      Integer stadim, ndim
      Parameter (stadim=500,ndim=500)
      Integer i, j, k, kk, n, uot, ust, udt, ustin, ustout
      Integer numst, numdat, keep(2), sindex
      Real  x(stadim), y(stadim), az(ndim), staloc(stadim,4)
      Real stdev(ndim), d(ndim)
      Character*8 sta(stadim), llcsn(2,ndim)
      uot     = 10
      ust     = 11
      udt     = 12
      ustout  = 6
C
C Get output file name.....
      Call getfile(uot,'Output file name','out','formatted')
      Call Gstalc(ustout,ust,stadim,x,y,sta,numst,staloc)
      Call Gdata(ustout,udt,ndim,numdat,llcsn,stdev,d)

      Do 300 n=1,numdat
      Do 200 i=1,2
              keep(i) = SIndex(sta,llcsn(i,n),numst)
  200 Continue
      k = keep(1)
      kk = keep(2)
C
      Write(uot,10) staloc(k,1),staloc(k,2),staloc(k,3),
     + staloc(k,4),staloc(kk,1),staloc(kk,2),staloc(kk,3),
     + staloc(kk,4)
   10  Format(8f8.2)
  300 Continue
C
      STOP
      END
 
