      Subroutine Ginput(uot,upm,uplt,mdim,dataop,uapr,alpha,
     +                                              solopt,plotnm)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  Get all input except stations and data.                       C
C  Get name of output file, prior model (if any), and type of    C
C  solution (inner, outer, model).                               C
C  Local Variables/Constants:                                    C
C  pmod   = option for prior model (y/n)                         C
C  pfile  = option for prior model file (y/n)                    C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      Integer i, m, n, uot, upm, uplt(5)
      Integer mdim
      Real uapr(mdim), pmodel, alpha
      real xnorth, xeast
      Character*80 ofile, pfname
      Character*1 pmod, pfile, dataop(10)
      Character*(*) plotnm(5),  solopt(5)
      Character*8 stanam

C ....Get output file name
      Call getfile2(uot,'Output file name','out','formatted',
     +              ofile)
      Write(uot,6) ofile
    6 Format(10x,'Output file: ',A)
      Write(uot,*)' '

c ....determine which data types are available
      call getopt('trilateration data available?','y/n','n',dataop(1))
      call getopt('triangulation data available?','y/n','n',dataop(2))
      call getopt('GPS vector data available?','   y/n','n',dataop(3))
      call getopt('VLBI vector data available?','  y/n','n',dataop(4))
      call getopt('Azimuth data available?    ','  y/n','n',dataop(5))

C.....Get solution type(s) and output plot filenames

C.....inner
      Call getopt('Inner coordinate solution?','y/n','n',solopt(1))
      If (solopt(1).eq.'y') Then
         Call getfile2(uplt(1),'Name for inner coord plot file',
     +                      'out','formatted',plotnm(1))
         Write(uot,*)' '
         Write(uot,25)plotnm(1)
   25    Format(10x,'inner coordinate solution plot file: ',A)
      EndIf

C.....outer
      Call getopt('Outer coordinate solution?','y/n','n',solopt(2))
      If (solopt(2).eq.'y') Then
      Print *, ' '      
      Print *, 'Favored direction is alpha degrees counter-clockwise 
     + from North'
      Call askreal('Input alpha ',alpha)
      Call getfile2(uplt(2),'Name for outer coord plot file',
     +                     'out','formatted',plotnm(2))
      Write(uot,30)plotnm(2)
   30 Format(10x,'outer coordinate solution plot file: ',A)
      Write(uot,35)alpha
   35 Format(15x,'alpha = ',f5.1)
      EndIf

C.....model
      Call getopt('Want model coordinate solution?','y/n','n',solopt(3))
      If (solopt(3).eq.'y') Then

      Print *, ' '
      Print *, 'You must have prior model file with format:'
      Print *, '  North component, East component, Station Name '
      Print *, '  Units are the same as data units (ie m, m/yr etc).'
      Print *, '  The order must be the same as order of stations in',
     +         ' station-coordinate file.'

      Call getfile2(upm,'Prior model file name','in',
     +                                     'formatted',pfname)
      Write(uot,10) pfname
   10 Format(10x,'Prior model file name : ',A)

C.....Read the prior model file
        i = 1
   15   Read(upm,100,end=17) xnorth,xeast,stanam
        Write(uot,100) xnorth,xeast,stanam
  100   format(22x,2e10.2,25x,a8)
          uapr(2*(i-1)+1) = xeast
          uapr(2*(i-1)+2) = xnorth
        i = i+1
        Go To 15
   17   Continue
        m = i-1
        Close(unit=upm)

      Call getfile2(uplt(3),'Name for model coord plot file',
     +                     'out','formatted',plotnm(3))
      Write(uot,40)plotnm(3)
   40 Format(10x,'model coordinate solution plot file: ',A)
      EndIf

C.....null vectors
      Call getopt('Want to save null vectors?','y/n','n',solopt(4))
      If (solopt(4).eq.'y') Then
         Call getfile2(uplt(4),'Name for null vector plot file',
     +                      'out','formatted',plotnm(4))
         Write(uot,*)' '
         Write(uot,45) plotnm(4)
   45    Format(10x,'Null vectors in plot file: ',A)
      EndIf

      RETURN
      END


