cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getfile(unit,question,inout,form)
c      Opens files...filenames not recognized by VAX will generate
c       an error message and request a second try.
c      Sample call:
c           call getfile(21,' Give input file','in','formatted')

      integer unit
      character filename*50, status*8
      character*(*) question, inout, form
      character bel*1
      parameter (bel=char(7))

      print *, ' '
 10   write(*,101) question(1:lentrue(question))//': '
 101  format('$',a,' ')
      read '(a50)', filename

c     Open the file with appropriate attributes...
      if(inout.eq.'in') then
        status='old'
        open(unit,file=filename,form=form,status=status,err=900,
     &     READONLY,SHARED)
c       (Note that READONLY and SHARED are VMS/VAX specific.)

      else if(inout.eq.'out') then
        status='new'
        if(form.eq.'formatted') then
          open(unit,file=filename,form=form,status=status,
     &    carriagecontrol='list',err=900)
        else if(form.eq.'fortran') then
          open(unit,file=filename,form='formatted',status=status,
     &    carriagecontrol='fortran',err=900)
        else if(form.eq.'unformatted') then
          open(unit,file=filename,form=form,status=status,err=900)
        endif

      else
        print *, ' ERROR...inout variable in GETFILE not recognized.'
        print *, '  inout =', inout
        stop

      endif

      return

c.....Error message for bad open...
 900  print *, bel
      print *,' ** Error in opening  ',filename(1:lentrue(filename)),
     &         ' .... Try again.'
      close(unit)
      print *, ' '
      go to 10

      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getfile2(unit,question,inout,form,filename)
c      Opens files...filenames not recognized by VAX will generate
c       an error message and request a second try.
c      Sample call:
c     call getfile2(unt,'Give input file','in','formatted',name)
      integer unit
      character  status*8
      character*(*) question, inout, form, filename
      character bel*1
      parameter (bel=char(7))

      print *, ' '
 10   write(*,101) question(1:lentrue(question))//': '
 101  format('$',a,' ')
      read '(a)', filename
c
c     Open the file with appropriate attributes...
      if(inout.eq.'in') then
        status='old'
        open(unit,file=filename,form=form,status=status,err=900,
     &     READONLY,SHARED)
c       (Note that READONLY and SHARED are VMS/VAX specific.)

      else if(inout.eq.'out') then
        status='new'
        if(form.eq.'formatted') then
          open(unit,file=filename,form=form,status=status,
     &    carriagecontrol='list',err=900)
        else if(form.eq.'fortran') then
          open(unit,file=filename,form='formatted',status=status,
     &    carriagecontrol='fortran',err=900)
        else if(form.eq.'unformatted') then
          open(unit,file=filename,form=form,status=status,err=900)
        endif

      else
        print *, ' ERROR...inout variable in GETFILE not recognized.'
        print *, '  inout =', inout
        stop

      endif

      return

c.....Error message for bad open...
 900  print *, bel
      print *,' ** Error in opening  ',filename(1:lentrue(filename)),
     &         ' .... Try again.'
      close(unit)
      print *, ' '
      go to 10

      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine askint(ques,int)
c     Asks a question and returns an integer answer.

      character*(*) ques
      character bel*1
      parameter (bel=char(7))

 10   print '(/,1h$,a)', ques(1:lentrue(ques))//':  '
      read (*,*,err=90)  int

      return

 90   print *, bel
      print *, ' Error...integer expected.  Try again...'
      goto 10

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine askreal(ques,real)
c     Asks a question and returns a real (floating) answer.

      character*(*) ques
      character bel*1
      parameter (bel=char(7))

 10   print '(/,1h$,a)', ques(1:lentrue(ques))//':  '
      read (*,*,err=90)  real

      return

 90   print *, bel
      print *, ' Error...expecting a real number...try again.'
      goto 10

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getstr(ques,strdefault,string)
c     Asks for a string...provides a default.
c         ques = question to be asked
c         strdefault = default string
c         string = answer

      character*(*) ques,strdefault,string, default*256
      character bel*1
      parameter (bel=char(7))

      default=strdefault
      call ljust(default)
      lengdef=lentrue(default)

      lengq=lentrue(ques)
 10   print '(/,1h$,a)', 
     &     ques(1:lengq)//':  ['//default(1:lengdef)//']  '
      read (*,'(a)') string
      leng=lentrue(string)
      if(leng.eq.0) then
        string=default
      endif

      return

c.....Error message
 90   print *, bel
      print '(/,1x,a)', 
     &  '*** ERROR, expecting a character string answer...try again...'
      goto 10

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getstr2(ques,strdefault,string,*)
c     Asks for a string...provides a default.
c         ques = question to be asked
c         strdefault = default string
c         string = answer
c           *    = statement number for conditional return1

      character*(*) ques,strdefault,string, default*256
      character bel*1
      parameter (bel=char(7))

      default=strdefault
      call ljust(default)
      lengdef=lentrue(default)

      lengq=lentrue(ques)
 10   print '(/,1h$,a)', 
     &     ques(1:lengq)//':  ['//default(1:lengdef)//']  '
      read (*,'(a)') string
      leng=lentrue(string)

      if(string.eq.'/'.or.string.eq.'\\') then
        string=default
        return1
      else if(leng.eq.0) then
        string=default
      endif

      return

c.....Error message
 90   print '(/,1x,a)', 
     &  '*** ERROR, expecting a character string answer...try again...'
      print *, bel
      goto 10

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getint(ques,intdefault,int)
c     Converts a string answer to an integer provided the string
c      is not blank...
c         ques = question to be asked
c         intdefault = default answer
c         int = integer answer

      integer int, intdefault
      character*(*) ques
      character*10 default, ans, fmt
      character bel*1
      parameter (bel=char(7))

      write(default,'(i10)') intdefault
      call ljust(default)
      lengdef=lentrue(default)

      lengq=lentrue(ques)
 10   print '(/,1h$,a)', 
     &     ques(1:lengq)//':  ['//default(1:lengdef)//']  '
      read (*,'(a)') ans
      leng=lentrue(ans)
      if(leng.eq.0) then
        int=intdefault
      else
        write(fmt,'(a,i3,a)') '(i', leng, ')'
        read(ans(1:leng),fmt,err=90) int
      endif

      return

c.....Error message
 90   print '(/,1x,a)', 
     &  '*** ERROR, expecting an integer answer...try again...'
      print *, bel
      goto 10

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getint2(ques,intdefault,int,*)
c     Converts a string answer to an integer provided the string
c      is not blank...
c         ques = question to be asked
c         intdefault = default answer
c         int = integer answer
c          *  = conditional return if answer is / or \

      integer int, intdefault
      character*(*) ques
      character*10 default, ans, fmt
      character bel*1
      parameter (bel=char(7))

      write(default,'(i10)') intdefault
      call ljust(default)
      lengdef=lentrue(default)

      lengq=lentrue(ques)
 10   print '(/,1h$,a)', 
     &     ques(1:lengq)//':  ['//default(1:lengdef)//']  '
      read (*,'(a)') ans
      leng=lentrue(ans)

      if(ans.eq.'/'.or.ans.eq.'\\') then
        return1
      else if(leng.eq.0) then
        int=intdefault
      else
        write(fmt,'(a,i3,a)') '(i', leng, ')'
        read(ans(1:leng),fmt,err=90) int
      endif

      return

c.....Error message
 90   print '(/,1x,a)', 
     &  '*** ERROR, expecting an integer answer...try again...'
      print *, bel
      goto 10

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getreal(ques,default,x)
c     Converts a string answer to a real number provided the string
c      is not blank...
c         ques = question to be asked
c         default = default answer given as character string
c         x = real number answer

      real default, x
      character*(*) ques
      character*10 ans, fmt, numb*20
      character bel*1
      parameter (bel=char(7))
      parameter (big = 1.0E6, small = 1.0E-3)

c     Write default to a character string
      if(abs(default).lt.big.and.abs(default).gt.small) then
        write(numb,'(f20.5)')  default
      else if(default.eq.0.0) then
        write(numb,'(f20.5)')  default
      else
        write(numb,'(1PE20.5)')  default
      endif
      call ljust(numb)
      lennumb=lentrue(numb)

c     Chop off trailing zeros from representation of default
      do 10 i=lennumb,1,-1
      if(numb(i:i).ne.'0') then
        lennumb = i
        goto 20
      endif
 10   continue

 20   lenq = lentrue(ques)
      print '(/,1h$,a)', ques(1:lenq)//':  ['//numb(1:lennumb)//']   '
      read (*,'(a)') ans

      leng=lentrue(ans)
      if(leng.eq.0)  then
        x = default
      else
        write(fmt,'(a,i3,a)') '(f', leng, '.0)'
        read(ans(1:leng),fmt,err=90)  x
      endif

      return

c.....Error message
 90   print '(/,1x,a)', 
     &  '*** ERROR, expecting a real number answer...try again...'
      print *, bel
      goto 20

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getreal2(ques,default,x,*)
c     Converts a string answer to a real number provided the string
c      is not blank...
c         ques = question to be asked
c         default = default real number answer
c         x = real answer
c         * = statement number for conditional return1

      real default, x
      character*(*) ques
      character*10 ans, fmt, numb*20
      character bel*1
      parameter (bel=char(7))
      parameter (big = 1.0E6, small = 1.0E-3)

c     Write default to a character string
      if(abs(default).lt.big.and.abs(default).gt.small) then
        write(numb,'(f20.5)')  default
      else if(default.eq.0.0) then
        write(numb,'(f20.5)')  default
      else
        write(numb,'(1PE20.5)')  default
      endif
      call ljust(numb)
      lennumb=lentrue(numb)

c     Chop off trailing zeros from representation of default
      do 10 i=lennumb,1,-1
      if(numb(i:i).ne.'0') then
        lennumb = i
        goto 20
      endif
 10   continue

 20   lenq = lentrue(ques)
      print '(/,1h$,a)', ques(1:lenq)//':  ['//numb(1:lennumb)//']   '
      read (*,'(a)') ans

      leng=lentrue(ans)
      if(ans.eq.'/'.or.ans.eq.'\\') then
        return1
      else if(leng.eq.0)  then
        x = default
      else
        write(fmt,'(a,i3,a)') '(f', leng, '.0)'
        read(ans(1:leng),fmt,err=90)  x
      endif

      return

c.....Error message
 90   print '(/,1x,a)', 
     &  '*** ERROR, expecting a real number answer...try again...'
      print *, bel
      goto 20

      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine getopt(ques,opts,default,answer)
c     Queries user for option desired--returns lower case answer.
c       ques = question.
c       opts = character string with options separated by , or / or 
c                almost anything else convenient.
c       default = default option to be used if a CR is the answer.
c       answer = option selected (or default).
c
c     Sample call:
c 
c       call getopt('Want tic marks?','y/n','n',answer)

      character*(*) ques, opts, default, answer
      character ans*10
      character bel*1
      parameter (bel=char('07'x))

      lengq=lentrue(ques)
      lengo=lentrue(opts)
      lengd=lentrue(default)

 10   print '(/,1h$,a)', ques(1:lengq)//' ('//opts(1:lengo)//
     &                     '):   '//'['//default(1:lengd)//']  '

      read '(a)', ans
      call ljust(ans)
      lenga=lentrue(ans)

      call uc2lc(opts)
      call uc2lc(default)
      call uc2lc(ans)

      if(ans.eq.' ') then
        answer = default
      else if(index(opts,ans(1:lenga)).eq.0) then
        print '(/,1x,a,a)', '****** ERROR...try again....',bel
        goto 10
      else
        answer = ans
      endif

      return
      end




C***** leftend.f *****
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer function leftend(string)
c     Gives position of first non-blank, non-tab, non-null
c      character in string.
c      Returns 0 if no such beast in string.
c     Programmed by R.Simpson - U.S.G.S.

      character*(*) string
      character*1 blank, tab, null
      parameter (blank=' ', tab=char(9), null=char(0))

      leftend=0

      do 100 i=1,len(string)
      if(string(i:i).ne.blank.and.
     &   string(i:i).ne.tab.and.
     &   string(i:i).ne.null) then
            leftend=i
            return
      endif
 100  continue

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer function lentrue(string)
c     Gives position of last non-blank, non-tab, non-null
c      character in string.
c      Returns 0 if no such beast in string

      character*(*) string
      character*1 blank, tab, null
      parameter (blank=' ', tab=char('11'O), null=char(0))

      lentrue=0

      do 100 i=len(string),1,-1
      if(string(i:i).ne.blank.and.
     &   string(i:i).ne.tab.and.
     &   string(i:i).ne.null) then
            lentrue=i
            return
      endif
 100  continue

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine lc2uc(string)
c     Converts lower case letters to upper case...
      character string*(*), s*1

      lstring=len(string)
      do 20 i=1,lstring
      s=string(i:i)
      if(s.ge.'a'. and .s.le.'z') then
       string(i:i)=char(ichar(s)-'a'+'A')
      endif
 20   continue

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine uc2lc(string)
c     Converts upper case letters to lower case...
      character string*(*), s*1

      lstring=len(string)
      do 20 i=1,lstring
      s=string(i:i)
      if(s.ge.'A'. and .s.le.'Z') then
       string(i:i)=char(ichar(s)-'A'+'a')
      endif
 20   continue

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ljust(string)
c     Left justifies a string by eliminating blanks, tabs, nulls
c      at left end of string.

      character*(*) string

      ifirst=leftend(string)

      if(ifirst.le.1) then
        return

      else
        l2=len(string)-(ifirst-1)
        string(1:l2)=string(ifirst:ifirst+l2-1)
        string(l2+1:len(string))=' '
      endif

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rjust(string)
c     Right justifies a string in its alloted length by eliminating
c      blanks, tabs, and nulls on the right end.

      character*(*) string

      leng=len(string)
      ilast=lentrue(string)
      if(ilast.eq.0.or.ilast.eq.leng) return

      do 100 i=1,ilast
 100  string(leng+1-i:leng+1-i)=string(ilast+1-i:ilast+1-i)

      do 200 i=ilast+1,leng
 200  string(leng+1-i:leng+1-i)=' '

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine ldeblank(string1,string2,l2)
c     Eliminates blanks at left end of string1,
c      returns as string2 with new length l2.

      character*(*) string1, string2

      ifirst=leftend(string1)
      l2=min(len(string2),len(string1)-(ifirst-1))
      string2(1:l2)=string1(ifirst:ifirst+l2-1)
      if(l2.lt.len(string2)) string2(l2+1:len(string2))=' '

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rdeblank(string1,string2,l2)
c     Eliminates blanks at right end of string1,
c      returns as string2 with new length l2.

      character*(*) string1, string2

      string2=string1
      l2=min(len(string2),lentrue(string1))

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine remblanks(string1,string2,len2)

c     Removes all blanks from string1, returns result as string2.
      character*(*) string1,string2

      string2 = ' '
      len1 = lentrue(string1)

      j=0
      do 50 i=1,len1
      if(string1(i:i).ne.' ') then
       j=j+1
       string2(j:j)=string1(i:i)
      endif
 50   continue

      len2=j

      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C+
C    IDEBLANK- removes all blanks and returns length
C
C    ireturn = IDEBLANK (string)
C
C       ireturn = length of the string without blanks
C        string = character string to be de-blanked
C
C-
C  *********************************************
      Integer Function ideblank(string)
      Character*256 string*(*),temp
      j=1
      temp=' '
      itemp=len(string)
      Do 10 i=1,itemp
      If (string(i:i).EQ.' ')Go To 10
      temp(j:j)=string(i:i)
      j=j+1
   10 Continue
      string=temp
      ideblank=j-1
      Return
      End
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine wrstring(iout,string)
c     Writes a string without trailing blanks, tabs, or nulls.
c      If string consists of only these characters, a single blank is 
c      written.

      character string*(*)

      leng=lentrue(string)

      if(leng.eq.0) then
        string=' '
        leng=1
      endif

      write(iout,'(1x,a)') string(1:leng)

      return
      end


